
import es, os
from configobj import ConfigObj

def ReWriteConfig(ServSecurityPassword):
    File = es.getAddonPath('servsecurity') + os.sep + "config_variables.ini"
    if not os.path.exists(File):
        return False
    Wrap = str(os.linesep)
    DWrap = Wrap + Wrap
    ConfigVariables = ConfigObj(File)
    ServSecurityCFG = "echo \"== ServSecurity.cfg START ==\"" + DWrap + "// Set your ServSecurity password. This password is required to unload ServSecurity" + Wrap + "servsecurity_setpassword \"" + ServSecurityPassword + "\"" + DWrap
    es.server.cmd("exec servsecurity")
    for cfg_var in ConfigVariables:
        Variable = "servsecurity_" + str(cfg_var)
        text = ConfigVariables[cfg_var]['text']
        Value = ConfigVariables[cfg_var]['default']
        if es.exists('variable', Variable):
            Value = es.ServerVar(Variable)

        ServSecurityCFG += "// " + str(text) + " (Default: \"" + ConfigVariables[cfg_var]['default'] + "\")" + Wrap + Variable + ' "' + Value + '"' + DWrap
    ServSecurityCFG += 'echo "== ServSecurity.cfg END =="'

    CFGFile = es.ServerVar('eventscripts_gamedir') + os.sep + "cfg" + os.sep + "servsecurity.cfg"
    try:
        os.chmod(CFGFile, 0777)
        fp = open(CFGFile, 'w')
        fp.write(ServSecurityCFG)
    except:
        return False
    finally:
        fp.close()
        return True